
.NOLIST
; 
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\counter2x.asm

rnMW 		    proto :dword
rnAbel1 	    proto :dword
rnLingo 	    proto :dword
rnAbel2 	    proto :dword
; 
seed0 equ 12345678h
.data
align 4
seed dd seed0
value dd 0
; 
.code
start:
; 
    print "HIGH_PRIORITY_CLASS",13,10
    mov  seed, seed0
    ctr_begin 1000, HIGH_PRIORITY_CLASS
        invoke rnMW, 256
    ctr_end
    print str$(eax)," cycles, Michael",13,10
    print str$(value)," = last value",13,10,13,10

    mov  seed, seed0
    ctr_begin 1000, HIGH_PRIORITY_CLASS
        invoke rnAbel1, 256
    ctr_end
    print str$(eax)," cycles, Abel Jcc",13,10
    print str$(value)," = last value",13,10,13,10

    mov  seed, seed0
    ctr_begin 1000, HIGH_PRIORITY_CLASS
        invoke rnLingo, 256
    ctr_end
    print str$(eax)," cycles, Lingo",13,10
    print str$(value)," = last value",13,10,13,10

    mov  seed, seed0
    ctr_begin 1000, HIGH_PRIORITY_CLASS
        invoke rnAbel2, 256
    ctr_end
    print str$(eax)," cycles, Abel CMOVcc",13,10
    print str$(value)," = last value",13,10,13,10


    print "REALTIME_PRIORITY_CLASS",13,10

    mov  seed, seed0
    ctr_begin 1000, REALTIME_PRIORITY_CLASS
        invoke rnMW, 256
    ctr_end
    print str$(eax)," cycles, Michael",13,10
    print str$(value)," = last value",13,10,13,10

    mov  seed, seed0
    ctr_begin 1000, REALTIME_PRIORITY_CLASS
        invoke rnAbel1, 256
    ctr_end
    print str$(eax)," cycles, Abel Jcc",13,10
    print str$(value)," = last value",13,10,13,10

    mov  seed, seed0
    ctr_begin 1000, REALTIME_PRIORITY_CLASS
        invoke rnLingo, 256
    ctr_end
    print str$(eax)," cycles, Lingo",13,10
    print str$(value)," = last value",13,10,13,10

    mov  seed, seed0
    ctr_begin 1000, REALTIME_PRIORITY_CLASS
        invoke rnAbel2, 256
    ctr_end
    print str$(eax)," cycles, Abel CMOVcc",13,10
    print str$(value)," = last value",13,10,13,10


    inkey "Press any key to exit..."
    exit
; 
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 4
rnMW proc base:DWORD
    mov ecx, seed
    mov edx, ecx
    sar edx, 16
    imul edx, edx, 16807
    movzx eax, cx
    imul eax, eax, 16807
    mov ecx, edx
    shr edx, 15
    and ecx, 32767
    sal ecx, 16
    add eax, ecx
    add eax, edx
    js  L2
  L1:
    xor edx, edx
    mov seed, eax
    div dword ptr[esp+4]
    mov value, edx
    ret 4
  L2:
    sub eax, 2147483647
    jmp L1
rnMW  endp

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 4
rnAbel1 proc base:DWORD
	mov   eax, 16807              ;a = 7^5
      mov   ecx, seed   
	mul   ecx                     ;edx:eax == a*seed == D:A
	mov	ecx,7fffffffh		;ecx = m
	add	edx,edx			;edx = 2*D
      cmp   eax,ecx			;eax = A
      jna   @F
      sub   eax,ecx			;if A>m, A = A - m
@@:	add	eax,edx			;eax = A + 2*D
	jns	@F
	sub	eax,ecx			;If (A + 2*D)>m
@@:	mov	seed,eax		      ;save new seed 
	xor	edx,edx
	div	dword ptr[esp+4]
	mov	value,edx
  	ret   4
rnAbel1  endp

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 4
rnLingo proc base:DWORD
	mov    eax, 16807       ;
	mul    seed             ;edx:eax == a*seed == D:A
	cmp    eax, 80000000h   ;   
	lea    ecx, [eax+edx*2-7fffffffh]
	sbb    eax, eax         ; eax->0 or -1
	shr    eax, 1           ; eax->0 or 7FFFFFFFh 
	xor    edx, edx 
	add    eax, ecx
	sets   dl
	mov    ecx, [esp+4]     ; ecx->base
	neg    edx              ; edx-> 0 or -1
	shr    edx, 1	        ; edx-> 0 or 7FFFFFFFh
	sub    eax, edx         ; eax-7FFFFFFFh or eax-0  
	xor    edx, edx 
	mov    seed, eax        ; save new seed 	
	div    ecx 
	mov    value, edx
	ret    4
rnLingo  endp


OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 4
rnAbel2 proc base:DWORD
    mov eax, 16807              ;a = 7^5
    mov ecx, 7fffffffh          ;ecx = m
    mul seed                    ;edx:eax == a*seed == D:A
    add edx, edx                ;edx = 2*D
    add eax,edx                 ;N = A + 2*D
    mov edx,0
    jnc @F                      ;if N > ffffffffh (less likely)
    sub eax,ecx                 ;  N = N-m
@@: cmovns  ecx,edx             ;if N > 7fffffffh (50:50)
    sub eax, ecx                ;  N = N-m
    mov seed, eax               ; save new seed
    div dword ptr [esp+4]       ;base
    mov value, edx
    ret 4
rnAbel2  endp
end start
 